import {
  login,
  logout,
  toggleCollect,
  toggleLike
} from '@/api/user'
import {
  getToken,
  setToken,
  removeToken,
  getUserInfo,
  setUserInfo,
  removeUserInfo
} from '@/utils/auth'


const getDefaultState = () => {
  return {
    token: getToken(),
    userInfo: getUserInfo(),
    name: '',
    avatar: '',
    // deptList:{}
  }
}

const state = getDefaultState()

const mutations = {
  RESET_STATE: (state) => {
    Object.assign(state, getDefaultState())
  },
  SET_TOKEN: (state, token) => {
    state.token = token
  },
  SET_NAME: (state, name) => {
    state.name = name
  },
  SET_AVATAR: (state, avatar) => {
    state.avatar = avatar
  },
  SET_USERINFO: (state, userInfo) => {
    state.userInfo = userInfo
  },
  // SET_DEPTLIST:(state,deptList)=>{
  //   state.deptList = deptList
  // }
}

const actions = {
  // user login
  login({
    commit
  }, userInfo) {
    const {
      username,
      password,
      captcha
    } = userInfo
    return new Promise((resolve, reject) => {
      login({
        username: username.trim(),
        password: password,
        captcha: captcha
      }).then(response => {
        const {
          data
        } = response
        commit('SET_TOKEN', data.accessToken)
        commit('SET_NAME', data.username)
        commit('SET_USERINFO', data)
        setToken(data.accessToken)
        setUserInfo(data)
        resolve()
      }).catch(error => {
        reject(error)
      })
    })
  },

  // user logout
  logout({
    commit,
    state
  }) {
    return new Promise((resolve, reject) => {
      logout(state.token).then(() => {
        removeToken() // must remove  token  first
        removeUserInfo()
        commit('RESET_STATE')
        resolve()
      }).catch(error => {
        console.log('err', error);
        // reject(error)
      })
    })
  },

  // remove token
  resetToken({
    commit
  }) {
    return new Promise(resolve => {
      removeToken() // must remove  token  first
      commit('RESET_STATE')
      resolve()
    })
  },

  // user logout
  toggleCollect({
    commit,
  }, data) {
    return new Promise((resolve, reject) => {
      toggleCollect(data).then((res) => {
        console.log('已成功收藏');
      }).catch(error => {
        console.log('err', error);
        // reject(error)
      })
    })
  },

  toggleLike({
    commit,
  }, data) {
    return new Promise((resolve, reject) => {
      toggleLike(data).then((res) => {
        // resolve()
        console.log('已成功点赞');
      }).catch(error => {
        console.log('err', error);
        // reject(error)
      })
    })
  },
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}
